MARTe2-core - User story #188

Object introspection base infrastructure
31.07.2015 15:49 - André Neto

Status: Closed Start date: 31.07.2015
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: 0.11 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Define the base infrastructure for object introspection.
This would satisfy requirements:

¢ MARTe-EX-F-2.2.1: The framework shall allow to fully introspect the properties of any of its object.
¢ MARTe-EX-F-2.2.2: The framework shall allow to introspect the class nhame of any of its objects.
¢ MARTe-EX-F-2.2.3: The framework shall allow to introspect the class type of any of its objects.

Source code files modified

LOTypes/BasicTypes.h
LOTypes/CompilerTypes.h
LOTypes/Introspection.h (Moved to L20bjects)
LOTypes/TypeDescriptor.h (Moved to L1Portability)
LOTypes/ZeroTerminatedArray.h
L1Portability/ErrorManagement.h
L1Portability/FormatDescriptor.cpp
L1Portability/TypeDescriptor.*
L1Portability/StringHelper.h
L20bjects/ClassRegistryltem.”
L20bjects/IntrospectionEntry.*
L20bjects/Introspection.*
L3Streams/IOBuffer.cpp
L4Configuration/ConfigurationDatabase.*
L4Configuration/TypeConversion.*
L4Configuration/ValidateBasicType.*
L3Streams/IOBuffer.*
Lib/IntrospectionParser.*

Architecture & design review
Date of the review: 31/07/2015
Person who did the review: Andre' Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support function and does
not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review

Date of the review: 01/02/2016
Person who did the review: Andre' Neto
Result of review: PASS
List of non-conformities:

e During Specific Walk:
File ./Source/Core/BareMetal/L3Streams/IOBufferintegerPrint.cpp line 531: MARTe::BitSetTolnteger(?, ?, ?, 87, 1=0) #1

File ./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h line 345: MARTe::BitSetToBitSet([1], 0, 8, 1, ?, ?, 87, |=0) #2
File ./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h line 286: MARTe::BSToBS([1], 0, 8, 1, ?, 317 | 07, 87, |=0) #3
File ./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h line 105: MARTe::MemoryOperationsHelper::Copy([4], ?, 5?) #31
./Source/Core/BareMetal/L1Portability/Environment/Generic/MemoryOperationsHelper_CLIB_Generic.cpp:58:1: Warning 669:
Possible data overrun for function 'memcpy(void *, const void *, unsigned long)', argument 3 (size=5) exceeds argument 1
(size=4)

./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h:101:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h:105:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h:227:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h:242:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h:286:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/BitSetTolnteger.h:345:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/IOBufferintegerPrint.cpp:528:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L3Streams/IOBufferintegerPrint.cpp:531:1: Info 831: Reference cited in prior message
./Source/Core/BareMetal/L4Configuration/Parserl.cpp:51:80: Note 9138: null statement not in line by itself [MISRA C++ Rule
6-2-3]

Unit test review

Date of the review: 03/02/2015

Person who did the review: lvan Herrero
Result of coverage tests review: PASS
Result of functional tests review: PASS
Result of review: PASS

List of non-conformities:

¢ Object::Clone(), and Object::Initialise() are not tested, but it is fine because they are not really implemented, yet.

¢ LexicalAnalyzer.cpp, IOBufferFloatPrint.cpp, and IOBuffer.cpp have some error handdling branches not covered, that consist of
a bit more than a simple error reporting sentence. Anyway, they have been left uncovered, because the error is hard to
simulate.

¢ The following tests on Windows platform fail:

[---------- ] Global test environment tear-down

[==========] 2502 tests from 75 test cases ran. (78098 ms total)

[ PASSED ] 2462 tests.

[ FAILED ] 40 tests, listed below:

[ FAILED ] AnyObjectGTest.TestGetType_Scalar_String

[ FAILED ] AnyTypeGTest.TestAnyType_ConstCharPointerToConst

[ FAILED ] BufferedStreamIGTest.TestPrintFormatted_CCString_BufferSize_1

[ FAILED ] BufferedStream|GTest.TestPrintFormatted CCString_BufferSize_2

[ FAILED ] BufferedStreamIGTest.TestPrintFormatted_CCString_BufferSize_8

[ FAILED ] BufferedStreamIGTest.TestPrintFormatted CCString_BufferSize_64

[ FAILED ] BufferedStreamIGTest.TestPrintFormatted CCString_BufferSize_128
[ FAILED ] BufferedStreamIGTest.TestPrintFormatted CCString_BufferSize_1024
[ FAILED ] ConfigurationDatabaseGTest.TestCopy
[ FAILED ] DirectoryGTest.TestGetLastAccessTime_ReRead
[ FAILED ] DirectoryGTest.TestGetLastAccessTime_ReRead2
[ FAILED ] I0BufferGTest.TestPrintFormatted_CCString
[ FAILED ] JsonParserGTest. TestParseVector
[ FAILED ] JsonParserGTest.TestParseMatrix
[ FAILED ] LoadableLibraryGTest.TestOpenCloseLibrary
[ FAILED ] LoadableLibraryGTest.TestCloseLibrary
[ FAILED ] LoadableLibraryGTest.TestLoadFunction
FAILED ] LoadableLibraryGTest.TestGetModule

FAILED ] MutexSemGTest.TestlsRecursive

FAILED ] MutexSemGTest.TestRecursiveOff

FAILED ] StreamMemoryReferenceGTest. TestAnyTypeOperator
FAILED ] StreamStringGTest. TestAnyTypeOperator

FAILED ] ThreadsGTest.TestBeginThreadStacksize0

FAILED ] TypeConversionGTest.Testint32ToCArrayVector
FAILED ] TypeConversionGTest.TestUInt32ToCArrayVector
FAILED ] TypeConversionGTest.TestFloat32ToCArrayVector
FAILED ] TypeConversionGTest. TestCCStringToCArrayVector
FAILED ] TypeConversionGTest.TestCArrayTolnt32Vector
FAILED ] TypeConversionGTest.TestCArrayToUInt32Vector
FAILED ] TypeConversionGTest.TestCArrayToFloat32Vector

FAILED ] TypeConversionGTest.TestCArrayToFloat32MatrixStaticToHeap
FAILED ] TypeConversionGTest.TestCArrayToCCStringVector

FAILED ] TypeConversionGTest.TestCArrayToCCStringMatrix

FAILED ] StandardParserGTest.TestParseVector

FAILED ] StandardParserGTest.TestParseMatrix

FAILED ] XMLParserGTest.TestParseVector

FAILED ] XMLParserGTest.TestParseMatrix

— e e e e e e e e e e e e e e e e

FAILED ] LoadableLibraryGTest.TestLoadFunctionSquareBracketsOperator

FAILED ] TypeConversionGTest.TestFloat32ToCArrayMatrixStaticToStatic
FAILED ] TypeConversionGTest.TestCArrayToFloat32MatrixStaticToStatic

Associated revisions

Revision c4beb5d4 - 29.09.2015 15:18 - Filippo Sartori

Merge branch 'master’ into #188_Introspection

Revision da35c940 - 29.09.2015 15:19 - Filippo Sartori

Merge branch 'master' into #188_Introspection

Revision ee8ad586 - 22.10.2015 12:21 - Filippo Sartori

Merge branch 'master’ into #188_Introspection

Conflicts:
Source/Core/BareMetal/L3Streams/AnyType.h

Revision 02b3550f - 18.01.2016 16:13 - Giuseppe Ferro

#188

-Created Introspection class

-Added the macro to register the introspection class to the
ClassRegistryDatabase

Revision e3f9b763 - 18.01.2016 16:14 - Giuseppe Ferro

#188
-Added Introspection class
-Added macro to register it into the ClassRegistryDatabase

Revision b97157e1 - 18.01.2016 16:30 - Giuseppe Ferro
#188 Added ZeroTerminatedArray

Revision 1d598e58 - 19.01.2016 18:43 - Giuseppe Ferro

#188 Added introspection tests

Added GetTypeCastDescriptor function to AnyTypeCreator

Added GetChildName and GetNumberOfChilds to ConfigurationDatabase
WIP Introspection parser

Revision 3599d735 - 20.01.2016 12:42 - Giuseppe Ferro

#188

-Added lookup table [basic type name - TypeDescriptor]

-Moved TypeDescriptor from Level0 to Level1 because it needs
StringHelper.

-Moved Introspection stuff to Level2 because IntrospectionEntry needs
ClassRegistryDatabase to build in runtime the TypeDescriptor if it is an
Object.
-Added the implementation of IntrospectionParser in the Lib folder

Revision ae722abf - 20.01.2016 13:04 - Giuseppe Ferro
#188 Linting done

Revision f2f827¢c0 - 20.01.2016 13:52 - Giuseppe Ferro

#188 Source code documentation done.

Revision e2a9866e - 20.01.2016 17:05 - Giuseppe Ferro

#188 Improved and documented Tests

Revision 9e02a299 - 20.01.2016 17:08 - Giuseppe Ferro

#188 Improved documentation of tests

Revision 45cf8438 - 20.01.2016 17:18 - Giuseppe Ferro
Merge remote-tracking branch 'origin/#296_GTest_Folder_Structure' into #188_0Object_Introspection

Revision efec44d0 - 20.01.2016 18:49 - Giuseppe Ferro

#188 Fixed and checked test coverage

Revision 59ac2744 - 21.01.2016 09:26 - Giuseppe Ferro

#188 Improved the IntrospectionParser in order to use different parsers.

Revision 749b5731 - 21.01.2016 09:28 - Giuseppe Ferro

#188 Removed a comment

Revision 4aaa97a4 - 21.01.2016 17:50 - Giuseppe Ferro
#188 Added ZeroTerminatedArray tests

Revision e3640f3b - 21.01.2016 18:18 - Giuseppe Ferro

#188 Improved documentation

Revision 2384a046 - 22.01.2016 10:17 - Giuseppe Ferro

#188
Added the pointer level to the function IsConstant in IntrospectionEntry
and the function GetMemberPointerLevel

Revision 3bdbe1{7 - 22.01.2016 18:08 - Giuseppe Ferro

#188 Work in progress struct type conversion

Revision 1adba2fd - 25.01.2016 18:55 - Giuseppe Ferro

#188 Added ValidateBasicType

Added tests on TypeConversion for structuredData

Added Read and Write for StructuredData for ConfigurationDatabase
Changed Copy to do a real ConfigurationDatabase copy

Revision ae53deb2 - 27.01.2016 18:41 - Giuseppe Ferro

#188

-Added Tests

-Improved linting and documentation

-Added print support of multidimensional, object, introspection and
buffered data

Revision f6abac40 - 29.01.2016 15:51 - Giuseppe Ferro
#188

-Finished Tests and Documentation

Revision 26354db2 - 29.01.2016 17:08 - Giuseppe Ferro
#188
-Adjusted IntrospectionParser with the new configuration

Revision 732857d3 - 29.01.2016 17:38 - Giuseppe Ferro

#188
Improved documentation

Revision 6ffcab7c - 29.01.2016 17:40 - Giuseppe Ferro

#188
Improved documentation

Revision 369fa7b6 - 31.01.2016 17:23 - André Neto
#188 Small lint and documentation corrections
Corrected some lint errors and clarified documentation.

Revision 08716¢63 - 01.02.2016 10:04 - Giuseppe Ferro
#188 Merge commit

Revision 5b4edb1e - 01.02.2016 10:04 - Giuseppe Ferro

Merge branch '#188_Object_Introspection' of https://vcis-gitlab.f4e.europa.eu/aneto/MARTe2.git into #188_0Object_Introspection

Revision d3b39159 - 01.02.2016 10:50 - Giuseppe Ferro
#188 Added the test of CLASS_INTROSPECTION_REGISTER macro

Revision e55a7b74 - 01.02.2016 16:08 - Ivan Herrero

#188 - Fix error on test value used in
IntrospectionTest::TestMacroToAddObjectClassRegistryDatabase().

Revision 3b041ee1 - 01.02.2016 16:37 - Ilvan Herrero

#188 - Finish incomplete postcondition on IntrospectionEntry constructor
and update its unit test.

Revision 56f4a945 - 01.02.2016 18:35 - Giuseppe Ferro
#188 Added tests

Revision 976feec5 - 01.02.2016 18:36 - Giuseppe Ferro
Merge branch '#188_Object_Introspection' of https://vcis-gitlab.f4e.europa.eu/aneto/MARTe2.git into #188_0Object_Introspection

Revision e2dc9c62 - 02.02.2016 10:34 - Giuseppe Ferro
#188 Improved testing

Revision d7a1d96e - 02.02.2016 11:22 - Giuseppe Ferro

#188
Added a test

Revision 3cfbc015 - 02.02.2016 11:23 - Ivan Herrero

#188 - Add postconditions on TypeDescriptor's constructors.

Revision bfe69342 - 02.02.2016 11:24 - lvan Herrero

Merge branch '#188_Object_Introspection' of https://vcis-gitlab.f4e.europa.eu/aneto/MARTe2.git into #188_Object_Introspection

Revision b90b7e75 - 02.02.2016 11:45 - lvan Herrero

#188 - Fix linting issue on Parserl.

Revision 013acbcd - 02.02.2016 12:09 - Giuseppe Ferro

#188 Change the BasicTCPSocket::WaitConnection from recursive to loop

Revision 3283c59c - 02.02.2016 12:10 - Giuseppe Ferro
Merge branch '#188_Object_Introspection' of https://vcis-gitlab.f4e.europa.eu/aneto/MARTe?2.git into #188_0Object_Introspection

Revision 98719977 - 03.02.2016 18:19 - lvan Herrero

#188 - Update StringHelper_CLIB_Generic.cpp and ErrorManagement.cpp to
last generic version.

Revision b8b94fa7 - 03.02.2016 18:20 - Ivan Herrero

#188 - Fix syntax error on
/Core/BareMetal/L1Portability/Environment/Windows/Makefile.inc (extra
tab removed).

Revision a1f7b00b - 03.02.2016 18:21 - lvan Herrero

#188 - Fix error TimeStamp.cpp (inclusion of ctime header was missing).

Revision 48e6ad1e - 03.02.2016 18:26 - lvan Herrero

#188 - Fix DLL exporting error (the BasicConsole::Close function has
been reverted to non-virtual because, for unknown reasons, it is not
exported when is virtual, so it is not found at runtime, hence making
the program to abort).

History

#1 - 31.07.2015 15:49 - André Neto

- Target version set to 0.3

#2 - 31.07.2015 16:10 - André Neto

- Description updated

#3 - 08.09.2015 12:39 - André Neto

- Target version changed from 0.3 to 0.5

#4 - 08.09.2015 12:56 - André Neto
- Status changed from New to Code: Impl

#5 - 27.09.2015 10:12 - André Neto

- Assignee set to Filippo Sartori

#6 - 29.09.2015 12:27 - André Neto

- Target version changed from 0.5 to 0.6

#7 - 26.10.2015 15:17 - lvan Herrero

- Target version changed from 0.6 to 0.7

#8 - 10.11.2015 17:36 - André Neto

- Target version changed from 0.7 to Backlog

#9 - 18.01.2016 10:57 - André Neto
- Assignee changed from Filippo Sartori to Giuseppe Ferro

- Target version deleted (Backlog)

#10 - 18.01.2016 12:28 - Giuseppe Ferro
- Status changed from Code: Impl to Code: Rev

#11 - 18.01.2016 12:34 - Giuseppe Ferro
- Description updated

- Assignee deleted (Giuseppe Ferro)

#12 - 18.01.2016 12:35 - Giuseppe Ferro

- Description updated
#13 - 18.01.2016 12:36 - Giuseppe Ferro
- Status changed from Code: Rev to Code: Impl

#14 - 18.01.2016 12:36 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#15 - 18.01.2016 13:09 - André Neto

- Target version set to 0.11

#16 - 21.01.2016 09:54 - Giuseppe Ferro

- Description updated

- Status changed from Code: Impl to Code: Rev
- Assignee deleted (Giuseppe Ferro)

code implementation done: 749b573
Created from #296_GTest_Folder_Structure

#17 - 22.01.2016 10:18 - Giuseppe Ferro

- Description updated

#18 - 26.01.2016 14:47 - Ivan Herrero
- Status changed from Code: Rev to Code: Impl

#19 - 29.01.2016 17:11 - Giuseppe Ferro

- Description updated

#20 - 29.01.2016 17:11 - Giuseppe Ferro
- Status changed from Code: Impl to Blocked

#21 - 29.01.2016 17:12 - Giuseppe Ferro
- Status changed from Blocked to Unit: Rev

#22 - 29.01.2016 17:12 - Giuseppe Ferro
- Status changed from Unit: Rev to Code: Rev

#23 - 29.01.2016 17:35 - Giuseppe Ferro

- Description updated

#24 - 31.01.2016 08:29 - André Neto

- Description updated

#25 - 31.01.2016 08:53 - André Neto

- Description updated

#26 - 31.01.2016 09:25 - André Neto

- Description updated

#27 - 31.01.2016 10:09 - André Neto

- Description updated

#28 - 31.01.2016 10:11 - André Neto

- Description updated

#29 - 31.01.2016 17:00 - André Neto

- Description updated
#30 - 31.01.2016 20:46 - André Neto

- Assignee set to André Neto

#31 - 01.02.2016 15:04 - André Neto

- Description updated

#32 - 01.02.2016 15:05 - André Neto
- Status changed from Code: Rev to Unit: Impl

#33 - 01.02.2016 15:05 - André Neto

- Assignee changed from André Neto to Ivan Herrero

#34 - 01.02.2016 15:05 - André Neto
- Status changed from Unit: Impl to Unit: Rev

#35 - 01.02.2016 17:46 - Ivan Herrero
- Description updated
- Status changed from Unit: Rev to Unit: Impl

- Assignee deleted (lvan Herrero)

#36 - 02.02.2016 09:08 - lvan Herrero

- Assignee set to Giuseppe Ferro

#37 - 02.02.2016 10:51 - Ivan Herrero
- Status changed from Unit: Impl to Unit: Rev

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#38 - 02.02.2016 12:16 - lvan Herrero

- Description updated

Unit test review finished on branch #188_Object_Introspection [b90b7e7].

#39 - 03.02.2016 19:57 - lvan Herrero

- Description updated

#40 - 04.02.2016 09:18 - Ivan Herrero
- Description updated
- Status changed from Unit: Rev to Closed

- Assignee deleted (Ilvan Herrero)

commit 17d5804ba45316e2875e1fe8ce29698b2e0bb009
Merge branch '#188_Object_Introspection' into develop

Conflicts:
Test/GTest/BareMetal/Makefile.inc
Test/GTest/FileSystem/Makefile.cov
Test/GTest/FileSystem/Makefile.inc
Test/GTest/Scheduler/Makefile.cov
Test/GTest/Scheduler/Makefile.inc
